#!/bin/env python

import ZODB

from ZODB.DemoStorage import DemoStorage
from ZODB.HashingSupport import *

from BTree import BTree

stor = DemoStorage()
db = ZODB.DB(stor)
conn = db.open()
root = conn.root()

map = HashablePersistentMapping(BTree())
root['map'] = map

p1 = HashablePersistent()
p2 = HashablePersistent()

map[p1] = 1
map[p2] = 2

assert map[p1] == 1
assert map[p2] == 2

get_transaction().commit()

assert map[p1] == 1
assert map[p2] == 2

p3 = HashablePersistent()
p4 = HashablePersistent()

map[p3] = 3
map[p4] = 4

assert map[p1] == 1
assert map[p2] == 2
assert map[p3] == 3
assert map[p4] == 4

get_transaction().commit()

assert map[p1] == 1
assert map[p2] == 2
assert map[p3] == 3
assert map[p4] == 4
